#include <stdio.h>
#include <string.h>
#include "arg.h"
#include "log.h"
#include "dep.h"
#include "db.h"
#include "tmpasm_scconfig.h"

static void vmma_set_debug(const char* val)
{
	put("/local/libvmma/debug", val);
}

static void vmma_set_prefix(const char* val)
{
	put("/local/libvmma/prefix", val);
}

static void vmma_hook_postinit(void)
{
	db_mkdir("/local");
	put("/local/libvmma/debug", sfalse);
	put("/local/libvmma/prefix", "/usr/local");
}

static int vmma_hook_detect_host(void)
{
	require("fstools/ar", 0, 0);

	return 0;
}

static int vmma_hook_detect_target(void)
{
	char key[64];

	require("cc/argstd/*", 0, 0);
	require("cc/fpic", 0, 0);
	require("cc/ldflags_so", 0, 0);
	require("cc/ldflags_dll", 0, 0);
	require("cc/wloutimplib", 0, 0);
	require("std/c99/uint8_t/presents", 0, 0);
	require("std/c99/uint64_t/presents", 0, 0);
	require("std/c99/uintptr_t/presents", 0, 0);
	require("sys/types/size/*", 0, 0);
	require("sys/ext_dynlib_native", 0, 0);
	require("thread/semget/*", 0, 0);
	require("thread/CreateSemaphore/*", 0, 0);
	require("libs/errno/*", 0, 0);

	if(0!=require("sys/types/void_ptr", 0, 0)) { return 1; }
	sprintf(key, "sys/types/size/%s_u_int", get("sys/types/void_ptr"));
	put("/local/libvmma/uintptr_t", get(key));

	require("cc/cc", 0, 0);
	require("cc/cflags", 0, 0);
	require("cc/argstd/std_c99", 0, 0);

	return 0;
}

static int vmma_hook_generate(const char* root)
{
	int generr = 0;

	fprintf(stderr, "Generating libvmma/Makefile (%d)\n", generr |= tmpasm(root, "Makefile.in", "Makefile"));
	fprintf(stderr, "Generating libvmma/config.h (%d)\n", generr |= tmpasm(root, "config.h.in", "config.h"));

	return generr;
}
