//================================================================================================
// $Id: wtc.cpp 6308 2023-01-16 20:16:41Z aron $
//
// Project:
//		Welltype Compiler
// Contents:
//		Welltype Compiler frontend
// Authors:
//		Aron Barath, 2014-2023
//================================================================================================
// Copyright (c) Aron Barath
//================================================================================================

#include <iostream>
#include <cstring>
#include "parserext.h"
#include "dumpast.h"
#include "codegen.h"
#include "wtparser/ast/ast_program.h"

/*
#define ENDL "\r\n"

static const char source1[] =
"#meta:title \"Test source\"" ENDL
"#meta:* __FILE__ = __DATETIME__" ENDL
"#include \"second.wt\"" ENDL
"" ENDL
"ctor" ENDL
"{" ENDL
"  string s;" ENDL
"}" ENDL
"" ENDL
"dtor" ENDL
"{" ENDL
"  string s1;" ENDL
"  ulong  ul;" ENDL
"  string s2;" ENDL
"}" ENDL
"" ENDL
"declare" ENDL
"{" ENDL
"  exception MyException;" ENDL
"}" ENDL
"" ENDL
"main" ENDL
"[" ENDL
"#datastacksize 0x100" ENDL
"#callstacksize 0x400" ENDL
"]" ENDL
"{" ENDL
"  int x, y;" ENDL
"  seq< seq< long > > z;" ENDL
"  bool b, b_2;" ENDL
"  b = false;" ENDL
"" ENDL
"  normal" ENDL
"  {" ENDL
"    seq< seq< string > > z, z2, z3, z4;" ENDL
"" ENDL
"    insert_test" ENDL
"    {" ENDL
"      i32 a_4;" ENDL
"      i64 b_8;" ENDL
"      i32 c_4;" ENDL
"      i64 d_8;" ENDL
"      i32 e_4;" ENDL
"      i32 f_4;" ENDL
"      i32 g_4;" ENDL
"    }" ENDL
"  }" ENDL
"" ENDL
"  yet_another" ENDL
"  {" ENDL
"    bool b1, b2, b3, b4;" ENDL
"" ENDL
"    b1 = true;" ENDL
"" ENDL
"    b1, b2, b3, b4 = false, b1, b, true;" ENDL
"  }" ENDL
"" ENDL
"  int init_lit = 123;" ENDL
"  int init_var = x;" ENDL
"  init_var = init_lit;" ENDL
"" ENDL
"  int i1, i2 = 1234, 5678;" ENDL
"  i1, i2 = i2, i1;" ENDL
"" ENDL
"  long L = 123456789l;" ENDL
"  ulong U = 123456789ul;" ENDL
"  L, U = 1234567890l, 1234567890ul;" ENDL
"" ENDL
"  string a_string = \"abcdef\";" ENDL
"  string line = __LINE__;" ENDL
"  a_string[0u] = 'A';" ENDL
"  a_string[2u] = line[0u];" ENDL
"" ENDL
"  exception(...)" ENDL
"  exhan" ENDL
"  {" ENDL
"  }" ENDL
"" ENDL
"  finally" ENDL
"  {" ENDL
"    write(\"finally\");" ENDL
"  }" ENDL
"}" ENDL
"" ENDL
"function func(int a1, long a2, string a3) : bool" ENDL
"pre { true }" ENDL
"{" ENDL
"  a1 = 1;" ENDL
"}" ENDL
"" ENDL
"function Print(string s)" ENDL
"pre { true }" ENDL
"{" ENDL
"  write(s);" ENDL
"}" ENDL
"" ENDL
"declare" ENDL
"{" ENDL
"  record Record" ENDL
"  {" ENDL
"    int i;" ENDL
"    long l;" ENDL
"    bool b;" ENDL
"  }" ENDL
"" ENDL
"  record Record2" ENDL
"  {" ENDL
"    Record r;" ENDL
"  }" ENDL
"}" ENDL
"" ENDL
"function record_test()" ENDL
"{" ENDL
"  Record2 rec2;" ENDL
"  rec2.r.l = 8888L;" ENDL
"  rec2.r.b = !rec2.r.b;" ENDL
"}" ENDL
"" ENDL
"function special_operator_tests()" ENDL
"{" ENDL
"  bool b1, b2   = true, false;" ENDL
"  bool and_then = b1 &&& b2;" ENDL
"  bool or_else  = b1 ||| b2;" ENDL
"}" ENDL
"" ENDL
"function read_test()" ENDL
"{" ENDL
"  string line1 = read();" ENDL
"  string line2 = read('\n');" ENDL
"  write(line1 + \"\\n\" + line2 + \"\\n\");" ENDL
"}" ENDL
"" ENDL
"function record_bool_function(Record2 rec2) : bool" ENDL
"{" ENDL
"  return rec2.r.i == 123;" ENDL
"}" ENDL
"" ENDL
"function loop_test()" ENDL
"{" ENDL
"  int x = 7;" ENDL
"" ENDL
"  while(x>0)" ENDL
"  {" ENDL
"    x = ( x - 1 ) / 2;" ENDL
"  }" ENDL
"" ENDL
"  do" ENDL
"  {" ENDL
"    x = 1;" ENDL
"  }" ENDL
"  while(x!=1);" ENDL
"" ENDL
"  for(x=0;x<9;x=x+1)" ENDL
"  {" ENDL
"  }" ENDL
"" ENDL
"  foreach(y in 1 to 100 which y!=50)" ENDL
"  {" ENDL
"  }" ENDL
"" ENDL
"  foreach(ch in \"demo string\")" ENDL
"  {" ENDL
"  }" ENDL
"" ENDL
"  seq<char> chars;" ENDL
"  foreach(ch in chars)" ENDL
"  {" ENDL
"  }" ENDL
"" ENDL
"  for(;;)" ENDL
"  {" ENDL
"    return;" ENDL
"  }" ENDL
"}" ENDL
"" ENDL
"export" ENDL
"{" ENDL
"  exception MyNearException;" ENDL
"}" ENDL
"" ENDL
"function raise_test(int x)" ENDL
"{" ENDL
"  if(1==x)" ENDL
"  {" ENDL
"    raise(MyException);" ENDL
"  }" ENDL
"  elif(x==2)" ENDL
"  {" ENDL
"    raise near(MyNearException);" ENDL
"  }" ENDL
"  else" ENDL
"  {" ENDL
"    write(\"raise_test: else\\n\");" ENDL
"  }" ENDL
"" ENDL
"  exception(MyNearException)" ENDL
"  {" ENDL
"    write(\"raise_test: MyNearException\\r\\n\");" ENDL
"  }" ENDL
"}" ENDL
"" ENDL
;

static const char source2[] =
"#meta:author \"Aron\"" ENDL
"#meta:* __FILE__ = __DATETIME__" ENDL
"" ENDL
"function f2(string s)" ENDL
"{" ENDL
"  write(s);" ENDL
"  write(\"test\");" ENDL
"}" ENDL
"" ENDL
;
*/

wtc::Options* init_options(int argc, char* argv[])
{
	wtc::Options* const opt = new wtc::Options(argc, argv);

	if(!opt)
	{
		std::cerr << "Error: Could not create option parser" << std::endl;
		return 0;
	}

	if(opt->HasProblem())
	{
		std::cerr << opt->GetProblem() << std::endl;
		delete opt;
		return 0;
	}

	return opt;
}

int ReturnWith(bool expect_error, int code)
{
	if(!expect_error)
	{
		return code;
	}

	return !code;
}

int main(int argc, char* argv[])
{
	wtc::ProblemHandler probhan;
	wtc::SourceManager srcman;
	wtc::Options* options = init_options(argc, argv);
	if(!options) { return 2; }

	wtast::Program* program = wtparser::Parse(options->GetSourceFilename(), &srcman, &probhan, options);

	if(program)
	{
		if(0==probhan.GetNumErrors())
		{
			if(options->DumpAst())
			{
				wtc::DumpAST(program);
			}

			if(!options->SyntaxOnly())
			{
				try
				{
					wtc::codegen::CodeGen codegen(options, &probhan, program);

					if(0==probhan.GetNumErrors() && !options->ExpectError())
					{
						codegen.Save(options->GetOutputFilename());
					}
				}
				catch(wtc::codegen::Exception & ex)
				{
					std::cout << ex.msg << std::endl;
					return ReturnWith(options->ExpectError(), 11);
				}
			}
		}

		delete program;
	}

	if(probhan.GetNumProblems())
	{
		std::cout << "There were " << probhan.GetNumProblems() << " problems:" << std::endl;

		for(wtc::ProblemHandler::iterator it=probhan.begin(),end=probhan.end();it!=end;++it)
		{
			std::cout << "  " << it->ToString() << std::endl;
		}

		if(probhan.GetNumErrors())
		{
			return ReturnWith(options->ExpectError(), 1);
		}
	}

	return ReturnWith(options->ExpectError(), 0);
}
