// $Id: parser.y 5373 2017-01-25 19:56:26Z aron $

%defines
%skeleton "lalr1.cc"
%output "parser.tab.cpp"
%start start
%locations
%expect 348
%define api.namespace {wtparser}
%define parser_class_name {WTParser}
%param {ParserHelper & helper}
%code requires {
#include "parser_pre.h"
#include "ParserHelper.h"
}
%code {
int yylex(wtparser::WTParser::semantic_type* value, wtparser::WTParser::location_type* location, wtparser::ParserHelper & helper);
}

%token                  END          0  "end of file"

%token OPT_DSS
%token OPT_CSS
%token TYPE_CHAR
%token TYPE_BOOL
%token TYPE_HANDLE
%token TYPE_I8
%token TYPE_U8
%token TYPE_I16
%token TYPE_U16
%token TYPE_I32
%token TYPE_U32
%token TYPE_I64
%token TYPE_U64
%token TYPE_F32
%token TYPE_F64
%token KW_SEQ
%token TYPE_STRING
%token TYPE_FILE
%token TYPE_DIR
%token TYPE_SOCKET
%token KW_TRUE
%token KW_FALSE
%token KW_FUNCTION
%token KW_EXCEPTION
%token KW_RAISE
%token KW_RAISENEAR
%token KW_FINALLY
%token KW_RETURN
%token KW_MAIN
%token KW_CTOR
%token KW_DTOR
%token KW_GLOBAL
%token KW_IMPORT
%token KW_EXPORT
%token KW_DECLARE
%token KW_MUTABLE
%token KW_DO
%token KW_IF
%token KW_ELSE
%token KW_ELIF
%token KW_FOR
%token KW_FOREACH
%token KW_WHILE
%token KW_IN
%token KW_INCLUSIVE
%token KW_EXCLUSIVE
%token KW_REVERSE
%token KW_WHICH
%token KW_RECORD
%token KW_PRE
%token KW_POST
%token KW_ASSERT
%token KW_LIMITED
%token KW_PRIVATE
%token KW_OPERATOR
%token KW_ALIAS
%token KW_PURE
%token KW_IMPURE
%token KW_OLD
%token KW_DATATYPE
%token KW_SWITCH
%token KW_CASE
%token KW_DEFAULT
%token KW_BREAK
%token KW_TYPE
%token KW_ENUM
%token SEMICOLON
%token COLON
%token COLONCOLON
%token DOT
%token DOTDOT
%token DOTDOTDOT
%token ASSIGN
%token LPAR
%token RPAR
%token LBRACKET
%token RBRACKET
%token LBRACE
%token RBRACE
%token META_AUTHOR
%token META_TITLE
%token META_VERSION
%token META_COPYRIGHT
%token META_ID
%token META_COMMENT
%token META__CUSTOM
%token PREDEF_FILE
%token PREDEF_LINE
%token PREDEF_DATE
%token PREDEF_TIME
%token PREDEF_DATETIME
%token <str> CHARLIT
%token <str> STRINGLIT
%token <str> IDENTIFIER
%token <str> TYPENAME
%token <str> SPECIALIDENT
%token <str> FLOATNUMBER
%token <str> DOUBLENUMBER
%token <str> I8DEC
%token <str> U8DEC
%token <str> I16DEC
%token <str> U16DEC
%token <str> I32DEC
%token <str> U32DEC
%token <str> I64DEC
%token <str> U64DEC
%token <str> I8HEX
%token <str> U8HEX
%token <str> I16HEX
%token <str> U16HEX
%token <str> I32HEX
%token <str> U32HEX
%token <str> I64HEX
%token <str> U64HEX
%token <str> I8BIN
%token <str> U8BIN
%token <str> I16BIN
%token <str> U16BIN
%token <str> I32BIN
%token <str> U32BIN
%token <str> I64BIN
%token <str> U64BIN
%token <str> I8OCT
%token <str> U8OCT
%token <str> I16OCT
%token <str> U16OCT
%token <str> I32OCT
%token <str> U32OCT
%token <str> I64OCT
%token <str> U64OCT
%token <str> UNBOUNDOPERATOR

%left COMMA

%left  <str> OP_LEFT03   OP_LORELSE
%right <str> OP_RIGHT03
%left  <str> OP_LEFT04   OP_LANDTHEN
%right <str> OP_RIGHT04
%left  <str> OP_LEFT05
%right <str> OP_RIGHT05
%left  <str> OP_LEFT06
%right <str> OP_RIGHT06
%left  <str> OP_LEFT07
%right <str> OP_RIGHT07
%left  <str> OP_LEFT08
%right <str> OP_RIGHT08
%left  <str> OP_LEFT09
%right <str> OP_RIGHT09
%left  <str> OP_LEFT10
%right <str> OP_RIGHT10
%left  <str> OP_LEFT11   LANGLEBRACKET RANGLEBRACKET
%right <str> OP_RIGHT11
%left  <str> OP_LEFT12
%right <str> OP_RIGHT12
%left  <str> OP_LEFT13
%right <str> OP_RIGHT13
%left  <str> OP_LEFT14
%right <str> OP_RIGHT14
%left  <str> OP_LEFT15
%right <str> OP_RIGHT15

%type <integer8>               integer8
%type <unsigned8>              unsigned8
%type <integer16>              integer16
%type <unsigned16>             unsigned16
%type <integer32>              integer32
%type <unsigned32>             unsigned32
%type <integer64>              integer64
%type <unsigned64>             unsigned64
%type <str>                    string
%type <str>                    stringlit
%type <entities>               entities
%type <entity>                 entity
%type <metadata>               metadata
%type <block>                  block
%type <exceptioncompound>      exceptioncompound
%type <throptions>             throptions
%type <throptions>             throptionlist
%type <statement>              statement
%type <statements>             statements
%type <ehandlers>              ehandlers
%type <finally>                finally
%type <compound>               compound
%type <ehandlerlist>           ehandlerlist
%type <variabledeclaration>    variabledeclaration
%type <type>                   type
%type <expression>             expression
%type <expression>             expression_opt
%type <expression>             funccallexpr
%type <lvalue>                 lvalue
%type <assignment>             assignment
%type <assignment>             assignment_builder
%type <assignment>             assignment_opt
%type <functionargument>       functionargument
%type <functionsignature>      functionsignature
%type <functionsignature>      funcsig_start
%type <functionsignature>      funcsig_args
%type <functionsignature>      funcsig_rets
%type <declaration>            declaration
%type <declarations>           declarations
%type <recordfield>            recordfield
%type <recordfields>           recordfields
%type <str>                    datatypeconsname
%type <datatypecons>           datatypecons_builder
%type <datatypecons>           datatypecons
%type <datatypeconses>         datatypeconses
%type <defaultstatement>       default_opt
%type <precond>                precond
%type <postcond>               postcond
%type <expression>             foreach_while
%type <expression>             foreach_which
%type <logical>                inclusive_opt
%type <logical>                reverse_opt
%type <statement>              elsestatement
%type <variabledecls>          variabledeclarations
%type <identlist>              identlist
%type <identlist>              identlist_opt
%type <fieldassign>            fieldassign
%type <fieldassigns>           fieldassigns
%type <enumerators>            enumerators
%type <enumerator>             enumerator
%type <switchcase>             switchcase
%type <switchcases>            switchcases

%union
{
	wt_i8                         integer8;
	wt_u8                         unsigned8;
	wt_i16                        integer16;
	wt_u16                        unsigned16;
	wt_i32                        integer32;
	wt_u32                        unsigned32;
	wt_i64                        integer64;
	wt_u64                        unsigned64;
	bool                          logical;
	std::string*                  str;
	wtast::Entity*                entity;
	wtast::Metadata*              metadata;
	wtast::Block*                 block;
	wtast::ExceptionCompound*     exceptioncompound;
	wtast::EHandlers*             ehandlers;
	wtast::Finally*               finally;
	wtast::Compound*              compound;
	wtast::Statement*             statement;
	wtast::VariableDeclaration*   variabledeclaration;
	wtast::Type*                  type;
	wtast::Expression*            expression;
	wtast::LValue*                lvalue;
	wtast::Assignment*            assignment;
	wtast::FunctionArgument*      functionargument;
	wtast::FunctionSignature*     functionsignature;
	wtast::Declaration*           declaration;
	wtast::RecordField*           recordfield;
	wtast::DataType*              datatype;
	wtast::DataTypeCons*          datatypecons;
	wtast::PreCondition*          precond;
	wtast::PostCondition*         postcond;
	wtast::FieldAssign*           fieldassign;
	wtast::DefaultStatement*      defaultstatement;
	wtast::EnumType*              enumtype;
	wtast::Enumerator*            enumerator;
	wtast::SwitchCase*            switchcase;
	statements_t*                 statements;
	entities_t*                   entities;
	throptions_t*                 throptions;
	ehandlerlist_t*               ehandlerlist;
	declarations_t*               declarations;
	recordfields_t*               recordfields;
	datatypeconses_t*             datatypeconses;
	variabledecls_t*              variabledecls;
	identlist_t*                  identlist;
	fieldassigns_t*               fieldassigns;
	enumerators_t*                enumerators;
	switchcases_t*                switchcases;
}

%%

start:
	END
	{
		helper.mRuleDebugger.PrintRule("start -> END");
		helper.mProgram = new wtast::Program();
	}
|
	entities END
	{
		helper.mRuleDebugger.PrintRule("start -> entities END");
		helper.mProgram = new wtast::Program($1->begin(), $1->end());
		delete $1;
	}
;

entities:
	entity
	{
		helper.mRuleDebugger.PrintRule("entities -> entity");
		$$ = new entities_t;

		if(helper.mDeclEntity)
		{
			$$->push_back(helper.mDeclEntity);
			helper.mDeclEntity = 0;
		}

		$$->push_back($1);
	}
|
	entities entity
	{
		helper.mRuleDebugger.PrintRule("entities -> entities entity");

		if(helper.mDeclEntity)
		{
			$$->push_back(helper.mDeclEntity);
			helper.mDeclEntity = 0;
		}

		$$->push_back($2);
	}
;

entity:
	metadata
	{
		helper.mRuleDebugger.PrintRule("entity -> metadata");
		$$ = $1;
	}
|
	block
	{
		helper.mRuleDebugger.PrintRule("entity -> block");
		$$ = $1;
	}
|
	KW_DECLARE LBRACE
	{
		helper.mDeclEntity = new wtast::DeclareBlock(false, false);
	}
	declarations RBRACE
	{
		helper.mRuleDebugger.PrintRule("entity -> KW_DECLARE LBRACE declarations RBRACE");
		$$ = helper.mDeclEntity;
		helper.mDeclEntity = 0;
		delete $4;
	}
|
	KW_IMPORT LBRACE
	{
		helper.mDeclEntity = new wtast::DeclareBlock(true, false);
	}
	declarations RBRACE
	{
		helper.mRuleDebugger.PrintRule("entity -> KW_IMPORT LBRACE declarations RBRACE");
		$$ = helper.mDeclEntity;
		helper.mDeclEntity = 0;
		delete $4;
	}
|
	KW_EXPORT LBRACE
	{
		helper.mDeclEntity = new wtast::DeclareBlock(false, true);
	}
	declarations RBRACE
	{
		helper.mRuleDebugger.PrintRule("entity -> KW_EXPORT LBRACE declarations RBRACE");
		$$ = helper.mDeclEntity;
		helper.mDeclEntity = 0;
		delete $4;
	}
|
	KW_GLOBAL LBRACE
	{
		helper.SetCurrentVariableClass(wtast::AstNode::Variable::GLOBAL);
	}
	variabledeclarations RBRACE
	{
		helper.mRuleDebugger.PrintRule("entity -> KW_GLOBAL LBRACE variabledeclarations RBRACE");
		$$ = new wtast::GlobalBlock($4->begin(), $4->end());
		helper.SetCurrentVariableClass(wtast::AstNode::Variable::LOCAL);
		delete $4;
	}
;

metadata:
	META_AUTHOR string
	{
		helper.mRuleDebugger.PrintRule("metadata -> META_AUTHOR string");
		$$ = new wtast::Metadata(WT_KEY_AUTHOR, *$2);
		delete $2;
	}
|
	META_TITLE string
	{
		helper.mRuleDebugger.PrintRule("metadata -> META_TITLE string");
		$$ = new wtast::Metadata(WT_KEY_TITLE, *$2);
		delete $2;
	}
|
	META_VERSION string
	{
		helper.mRuleDebugger.PrintRule("metadata -> META_VERSION string");
		$$ = new wtast::Metadata(WT_KEY_VERSION, *$2);
		delete $2;
	}
|
	META_COPYRIGHT string
	{
		helper.mRuleDebugger.PrintRule("metadata -> META_COPYRIGHT string");
		$$ = new wtast::Metadata(WT_KEY_COPYRIGHT, *$2);
		delete $2;
	}
|
	META_ID string
	{
		helper.mRuleDebugger.PrintRule("metadata -> META_ID string");
		$$ = new wtast::Metadata(WT_KEY_ID, *$2);
		delete $2;
	}
|
	META_COMMENT string
	{
		helper.mRuleDebugger.PrintRule("metadata -> META_COMMENT string");
		$$ = new wtast::Metadata(WT_KEY_COMMENT, *$2);
		delete $2;
	}
|
	META__CUSTOM string ASSIGN string
	{
		helper.mRuleDebugger.PrintRule("metadata -> META__CUSTOM string ASSIGN string");
		$$ = new wtast::Metadata(*$2, *$4);
		delete $2;
		delete $4;
	}
;

string:
	stringlit
	{
		helper.mRuleDebugger.PrintRule("string -> stringlit");
		$$ = new std::string(*$1);
		delete $1;
	}
|
	stringlit string
	{
		helper.mRuleDebugger.PrintRule("string -> stringlit string");
		$$ = new std::string(*$1 + *$2);
		delete $1;
		delete $2;
	}
;

stringlit:
	STRINGLIT
	{
		helper.mRuleDebugger.PrintRule("stringlit -> STRINGLIT");
		$$ = new std::string(helper.ParseString(*$1));
		delete $1;
	}
|
	PREDEF_FILE
	{
		helper.mRuleDebugger.PrintRule("stringlit -> PREDEF_FILE");
		$$ = new std::string(helper.FileAsString());
	}
|
	PREDEF_LINE
	{
		helper.mRuleDebugger.PrintRule("stringlit -> PREDEF_LINE");
		$$ = new std::string(helper.LineAsString());
	}
|
	PREDEF_DATE
	{
		helper.mRuleDebugger.PrintRule("stringlit -> PREDEF_DATE");
		$$ = new std::string(helper.DateAsString());
	}
|
	PREDEF_TIME
	{
		helper.mRuleDebugger.PrintRule("stringlit -> PREDEF_TIME");
		$$ = new std::string(helper.TimeAsString());
	}
|
	PREDEF_DATETIME
	{
		helper.mRuleDebugger.PrintRule("stringlit -> PREDEF_DATETIME");
		$$ = new std::string(helper.DateAsString() + " " + helper.TimeAsString());
	}
;

block:
	KW_MAIN throptions { helper.EnterDistinguishedBlockMode(true); if(!helper.mSymTab.EnterBlock("main")) { helper.PostError("Out of memory."); } } exceptioncompound
	{
		helper.mRuleDebugger.PrintRule("block -> KW_MAIN throptions exceptioncompound");
		helper.mSymTab.LeaveBlock();
		helper.LeaveDistinguishedBlockMode();
		$$ = new wtast::MainBlock($4, $2->css, $2->dss);
		delete $2;
	}
|
	KW_CTOR { helper.EnterDistinguishedBlockMode(true); if(!helper.mSymTab.EnterBlock("ctor")) { helper.PostError("Out of memory."); } } exceptioncompound
	{
		helper.mRuleDebugger.PrintRule("block -> KW_CTOR exceptioncompound");
		helper.mSymTab.LeaveBlock();
		helper.LeaveDistinguishedBlockMode();
		$$ = new wtast::ConstructorBlock($3);
	}
|
	KW_DTOR { helper.EnterDistinguishedBlockMode(true); if(!helper.mSymTab.EnterBlock("dtor")) { helper.PostError("Out of memory."); } } exceptioncompound
	{
		helper.mRuleDebugger.PrintRule("block -> KW_DTOR exceptioncompound");
		helper.mSymTab.LeaveBlock();
		helper.LeaveDistinguishedBlockMode();
		$$ = new wtast::DestructorBlock($3);
	}
|
	functionsignature
	{
		if(!helper.mSymTab.EnterBlock($1->GetName()))
		{
			helper.PostError("Out of memory.");
		}

		for(std::size_t idx=0,num=$1->GetArgc();idx<num;++idx)
		{
			wtast::FunctionArgument* arg = $1->GetArg(idx);

			arg->SetUniqueId(helper.CreateUniqueId());
			if(!helper.mSymTab.AddVariable(arg->GetType(), arg->GetName(), arg->GetUniqueId(), helper._GetEHandlerMode(), wtast::AstNode::Variable::FORMAL))
			{
				helper.PostError(std::string("Multiple variable declaration of '") + arg->GetName() + "'");
			}
		}

		helper.EnterCurrentFunction($1);
	}
	attributes precond postcond exceptioncompound
	{
		helper.mRuleDebugger.PrintRule("block -> functionsignature precond postcond exceptioncompound");
		helper.mSymTab.LeaveBlock();
		helper.LeaveCurrentFunction();
		$$ = helper.MakeFunctionDefinition($1, $4, $5, $6);
	}
;

attributes:
	// empty
	{
		//$$ = 0;
	}
;

precond:
	// empty
	{
		helper.mRuleDebugger.PrintRule("precond -> {empty}");
		$$ = 0;
	}
|
	KW_PRE LBRACE expression RBRACE
	{
		helper.mRuleDebugger.PrintRule("precond -> KW_PRE LBRACE expression RBRACE");
		$$ = helper.MakePrecondition($3);
	}
;

postcond:
	// empty
	{
		helper.mRuleDebugger.PrintRule("postcond -> {empty}");
		$$ = 0;
	}
|
	KW_POST LPAR identlist_opt RPAR
	{
		$<variabledecls>$ = helper.AddPostcondRets($3);
	}
	LBRACE identlist_opt SEMICOLON
	{
		$<variabledecls>$ = helper.AddPostcondOlds($7);
	}
	expression RBRACE
	{
		helper.mRuleDebugger.PrintRule("postcond -> KW_POST LPAR identlist_opt RPAR LBRACE identlist_opt SEMICOLON expression RBRACE");
		variabledecls_t* rets = $<variabledecls>5;
		variabledecls_t* olds = $<variabledecls>9;
		$$ = helper.MakePostcondition(rets, olds, $10);
		delete rets;
		delete olds;
	}
;

identlist:
	IDENTIFIER
	{
		helper.mRuleDebugger.PrintRule("identlist -> IDENTIFIER");
		$$ = new identlist_t;
		$$->push_back(*$1);
		delete $1;
	}
|
	identlist COMMA IDENTIFIER
	{
		helper.mRuleDebugger.PrintRule("identlist -> identlist COMMA IDENTIFIER");
		$$ = $1;
		$$->push_back(*$3);
		delete $3;
	}
;

identlist_opt:
	// empty
	{
		helper.mRuleDebugger.PrintRule("identlist_opt -> {empty}");
		$$ = 0;
	}
|
	identlist
	{
		helper.mRuleDebugger.PrintRule("identlist_opt -> identlist");
		$$ = $1;
	}
;

declarations:
	// empty
	{
		helper.mRuleDebugger.PrintRule("declarations -> {empty}");
		$$ = new declarations_t;
	}
|
	declarations declaration
	{
		helper.mRuleDebugger.PrintRule("declarations -> declarations declaration");
		$$ = $1;

		if($2)
		{
			$$->push_back($2);
			helper.AddDeclaration($2);
		}
	}
;

declaration:
	functionsignature SEMICOLON
	{
		helper.mRuleDebugger.PrintRule("declaration -> functionsignature SEMICOLON");
		$$ = helper.MakeFunctionDeclaration($1);
	}
|
	KW_TYPE functionsignature SEMICOLON
	{
		helper.mRuleDebugger.PrintRule("declaration -> KW_TYPE functionsignature SEMICOLON");
		$$ = helper.MakeFunctionTypeDeclaration($2);
	}
|
	KW_RECORD IDENTIFIER LBRACE recordfields RBRACE
	{
		helper.mRuleDebugger.PrintRule("declaration -> KW_RECORD IDENTIFIER LBRACE recordfields RBRACE");
		$$ = helper.MakeRecordDeclaration(*$2, *$4, false, false, false);
		delete $2;
		delete $4;
	}
|
	KW_PRIVATE KW_RECORD IDENTIFIER LBRACE recordfields RBRACE
	{
		helper.mRuleDebugger.PrintRule("declaration -> KW_PRIVATE KW_RECORD IDENTIFIER LBRACE recordfields RBRACE");
		if(helper.mDeclEntity->IsExport())
		{
			$$ = helper.MakeRecordDeclaration(*$3, *$5, true, false, false);
		}
		else
		{
			helper.PostError("Cannot import private record with fields.");
			$$ = 0;
		}
		delete $3;
		delete $5;
	}
|
	KW_PRIVATE KW_RECORD IDENTIFIER SEMICOLON
	{
		helper.mRuleDebugger.PrintRule("declaration -> KW_PRIVATE KW_RECORD IDENTIFIER SEMICOLON");
		if(helper.mDeclEntity->IsImport())
		{
			recordfields_t no_fields;
			$$ = helper.MakeRecordDeclaration(*$3, no_fields, true, false, true);
		}
		else
		{
			helper.PostError("Cannot declare exportable private record without fields.");
			$$ = 0;
		}
		delete $3;
	}
|
	KW_LIMITED KW_RECORD IDENTIFIER LBRACE recordfields RBRACE
	{
		helper.mRuleDebugger.PrintRule("declaration -> KW_LIMITED KW_RECORD IDENTIFIER LBRACE recordfields RBRACE");
		if(helper.mDeclEntity->IsExport())
		{
			$$ = helper.MakeRecordDeclaration(*$3, *$5, false, true, false);
		}
		else
		{
			helper.PostError("Cannot import limited record with fields.");
			$$ = 0;
		}
		delete $3;
		delete $5;
	}
|
	KW_LIMITED KW_RECORD IDENTIFIER SEMICOLON
	{
		helper.mRuleDebugger.PrintRule("declaration -> KW_LIMITED KW_RECORD IDENTIFIER SEMICOLON");
		if(helper.mDeclEntity->IsImport())
		{
			recordfields_t no_fields;
			$$ = helper.MakeRecordDeclaration(*$3, no_fields, false, true, true);
		}
		else
		{
			helper.PostError("Cannot declare exportable limited record without fields.");
			$$ = 0;
		}
		delete $3;
	}
|
	KW_EXCEPTION IDENTIFIER SEMICOLON
	{
		helper.mRuleDebugger.PrintRule("declaration -> KW_EXCEPTION IDENTIFIER SEMICOLON");
		$$ = helper.MakeExceptionDeclaration(*$2);
		delete $2;
	}
|
	KW_OPERATOR UNBOUNDOPERATOR IDENTIFIER integer32 SEMICOLON
	{
		helper.mRuleDebugger.PrintRule("declaration -> KW_OPERATOR UNBOUNDOPERATOR IDENTIFIER integer32 SEMICOLON");
		$$ = helper.MakeOperatorDeclaration(*$2, *$3, $4);
		delete $2;
		delete $3;
	}
|
	KW_OPERATOR IDENTIFIER IDENTIFIER integer32 SEMICOLON
	{
		helper.mRuleDebugger.PrintRule("declaration -> KW_OPERATOR IDENTIFIER IDENTIFIER integer32 SEMICOLON");
		$$ = helper.MakeOperatorDeclaration(*$2, *$3, $4);
		delete $2;
		delete $3;
	}
|
	KW_OPERATOR string IDENTIFIER integer32 SEMICOLON
	{
		helper.mRuleDebugger.PrintRule("declaration -> KW_OPERATOR string IDENTIFIER integer32 SEMICOLON");
		$$ = helper.MakeOperatorDeclaration(*$2, *$3, $4);
		delete $2;
		delete $3;
	}
|
	KW_ALIAS IDENTIFIER type SEMICOLON
	{
		helper.mRuleDebugger.PrintRule("declaration -> KW_ALIAS IDENTIFIER type SEMICOLON");
		$$ = helper.MakeAliasDeclaration(*$2, $3);
		delete $2;
	}
|
	KW_DATATYPE IDENTIFIER LBRACE
	{
		wtast::DataType* datatype = helper.MakeDataType(*$2);
		helper.SetCurrentDataType(datatype);
		$<datatype>$ = datatype;
	}
	datatypeconses RBRACE
	{
		helper.mRuleDebugger.PrintRule("declaration -> KW_DATATYPE IDENTIFIER LBRACE datatypeconses RBRACE");
		wtast::DataType* datatype = $<datatype>4;
		$$ = helper.MakeDataTypeDeclaration(datatype, *$5);
		helper.SetCurrentDataType(0);
		delete $2;
		delete $5;
	}
|
	KW_ENUM IDENTIFIER LBRACE
	{
		wtast::EnumType* enumtype = helper.MakeEnumType(*$2);
		helper.SetCurrentEnumType(enumtype);
		$<enumtype>$ = enumtype;
	}
	enumerators RBRACE
	{
		helper.mRuleDebugger.PrintRule("declaration -> KW_ENUM IDENTIFIER LBRACE enumerators RBRACE");
		wtast::EnumType* enumtype = $<enumtype>4;
		$$ = helper.MakeEnumTypeDeclaration(enumtype, *$5);
		helper.SetCurrentEnumType(0);
		delete $2;
		delete $5;
	}
;

recordfields:
	// empty
	{
		helper.mRuleDebugger.PrintRule("recordfields -> {empty}");
		$$ = new recordfields_t;
	}
|
	recordfields recordfield
	{
		helper.mRuleDebugger.PrintRule("recordfields -> recordfields recordfield");
		$$ = $1;
		$$->push_back($2);
	}
;

recordfield:
	type IDENTIFIER SEMICOLON
	{
		helper.mRuleDebugger.PrintRule("recordfield -> type IDENTIFIER SEMICOLON");
		$$ = helper.MakeRecordField($1, *$2);
		delete $2;
	}
;

enumerators:
	enumerator
	{
		helper.mRuleDebugger.PrintRule("enumerators -> enumerator");
		$$ = new enumerators_t;
		$$->push_back($1);
	}
|
	enumerators COMMA enumerator
	{
		helper.mRuleDebugger.PrintRule("enumerators -> enumerators COMMA enumerator");
		$$ = $1;
		$$->push_back($3);
	}
;

enumerator:
	IDENTIFIER
	{
		helper.mRuleDebugger.PrintRule("enumerator -> IDENTIFIER");
		$$ = helper.MakeEnumerator(*$1);
		delete $1;		
	}
|
	SPECIALIDENT
	{
		helper.mRuleDebugger.PrintRule("enumerator -> SPECIALIDENT");
		$$ = helper.MakeEnumerator(*$1);
		delete $1;		
	}
;

datatypeconses:
	datatypecons
	{
		helper.mRuleDebugger.PrintRule("datatypeconses -> datatypecons");
		$$ = new datatypeconses_t;
		$$->push_back($1);
	}
|
	datatypeconses datatypecons
	{
		helper.mRuleDebugger.PrintRule("datatypeconses -> datatypeconses datatypecons");
		$$ = $1;
		$$->push_back($2);
	}
;

datatypeconsname:
	IDENTIFIER
	{
		helper.mRuleDebugger.PrintRule("datatypeconsname -> IDENTIFIER");
		$$ = $1;
	}
|
	SPECIALIDENT
	{
		helper.mRuleDebugger.PrintRule("datatypeconsname -> SPECIALIDENT");
		$$ = $1;
	}
;

datatypecons:
	datatypeconsname SEMICOLON
	{
		helper.mRuleDebugger.PrintRule("datatypecons -> datatypeconsname SEMICOLON");
		$$ = helper.MakeDataTypeCons(*$1);
		delete $1;
	}
|
	KW_DEFAULT datatypeconsname SEMICOLON
	{
		helper.mRuleDebugger.PrintRule("datatypecons -> KW_DEFAULT datatypeconsname SEMICOLON");
		$$ = helper.MakeDataTypeCons(*$2);
		$$->SetDefault(true);
		delete $2;
	}
|
	datatypecons_builder SEMICOLON
	{
		helper.mRuleDebugger.PrintRule("datatypecons -> datatypecons_builder SEMICOLON");
		$$ = $1;
	}
;

datatypecons_builder:
	IDENTIFIER type
	{
		helper.mRuleDebugger.PrintRule("datatypecons_builder -> IDENTIFIER type");
		$$ = helper.MakeDataTypeCons(*$1);
		$$->AddTypeBack($2);
		delete $1;
	}
|
	datatypecons_builder COMMA type
	{
		helper.mRuleDebugger.PrintRule("datatypecons_builder -> datatypecons_builder COMMA type");
		$$ = $1;
		$$->AddTypeBack($3);
	}
;

exceptioncompound:
	LBRACE statements { helper.EnterEHandlerMode(true); } ehandlers finally RBRACE
	{
		helper.mRuleDebugger.PrintRule("exceptioncompound -> LBRACE statements ehandlers finally RBRACE");
		$$ = new wtast::ExceptionCompound($2->begin(), $2->end(), $4, $5);
		helper.LeaveEHandlerMode();
		delete $2;
	}
;

throptions:
	// empty
	{
		helper.mRuleDebugger.PrintRule("throptions -> {empty}");
		$$ = new throptions_t;
	}
|
	LBRACKET throptionlist RBRACKET
	{
		helper.mRuleDebugger.PrintRule("throptions -> LBRACKET throptionlist RBRACKET");
		$$ = $2;
	}
;

throptionlist:
	OPT_DSS integer32
	{
		helper.mRuleDebugger.PrintRule("throptionlist -> OPT_DSS integer32");
		$$ = new throptions_t;
		$$->dss = (wt_u32)$2;
	}
|
	OPT_CSS integer32
	{
		helper.mRuleDebugger.PrintRule("throptionlist -> OPT_CSS integer32");
		$$ = new throptions_t;
		$$->css = (wt_u32)$2;
	}
|
	throptionlist OPT_DSS integer32
	{
		helper.mRuleDebugger.PrintRule("throptionlist -> throptionlist OPT_DSS integer32");
		$$ = $1;
		$$->dss = (wt_u32)$3;
	}
|
	throptionlist OPT_CSS integer32
	{
		helper.mRuleDebugger.PrintRule("throptionlist -> throptionlist OPT_CSS integer32");
		$$ = $1;
		$$->css = (wt_u32)$3;
	}
;

integer8:
	I8BIN
	{
		helper.mRuleDebugger.PrintRule("integer8 -> I8BIN");
		$$ = helper.BinToI8(*$1);
		delete $1;
	}
|
	I8OCT
	{
		helper.mRuleDebugger.PrintRule("integer8 -> I8OCT");
		$$ = helper.OctToI8(*$1);
		delete $1;
	}
|
	I8DEC
	{
		helper.mRuleDebugger.PrintRule("integer8 -> I8DEC");
		$$ = helper.DecToI8(*$1);
		delete $1;
	}
|
	I8HEX
	{
		helper.mRuleDebugger.PrintRule("integer8 -> I8HEX");
		$$ = helper.HexToI8(*$1);
		delete $1;
	}
;

unsigned8:
	U8BIN
	{
		helper.mRuleDebugger.PrintRule("unsigned8 -> U8BIN");
		$$ = helper.BinToI8(*$1);
		delete $1;
	}
|
	U8OCT
	{
		helper.mRuleDebugger.PrintRule("unsigned8 -> U8OCT");
		$$ = helper.OctToI8(*$1);
		delete $1;
	}
|
	U8DEC
	{
		helper.mRuleDebugger.PrintRule("unsigned8 -> U8DEC");
		$$ = helper.DecToI8(*$1);
		delete $1;
	}
|
	U8HEX
	{
		helper.mRuleDebugger.PrintRule("unsigned8 -> U8HEX");
		$$ = helper.HexToI8(*$1);
		delete $1;
	}
;

integer16:
	I16BIN
	{
		helper.mRuleDebugger.PrintRule("integer16 -> I16BIN");
		$$ = helper.BinToI16(*$1);
		delete $1;
	}
|
	I16OCT
	{
		helper.mRuleDebugger.PrintRule("integer16 -> I16OCT");
		$$ = helper.OctToI16(*$1);
		delete $1;
	}
|
	I16DEC
	{
		helper.mRuleDebugger.PrintRule("integer16 -> I16DEC");
		$$ = helper.DecToI16(*$1);
		delete $1;
	}
|
	I16HEX
	{
		helper.mRuleDebugger.PrintRule("integer16 -> I16HEX");
		$$ = helper.HexToI16(*$1);
		delete $1;
	}
;

unsigned16:
	U16BIN
	{
		helper.mRuleDebugger.PrintRule("unsigned16 -> U16BIN");
		$$ = helper.BinToI16(*$1);
		delete $1;
	}
|
	U16OCT
	{
		helper.mRuleDebugger.PrintRule("unsigned16 -> U16OCT");
		$$ = helper.OctToI16(*$1);
		delete $1;
	}
|
	U16DEC
	{
		helper.mRuleDebugger.PrintRule("unsigned16 -> U16DEC");
		$$ = helper.DecToI16(*$1);
		delete $1;
	}
|
	U16HEX
	{
		helper.mRuleDebugger.PrintRule("unsigned16 -> U16HEX");
		$$ = helper.HexToI16(*$1);
		delete $1;
	}
;

integer32:
	I32BIN
	{
		helper.mRuleDebugger.PrintRule("integer32 -> I32BIN");
		$$ = helper.BinToI32(*$1);
		delete $1;
	}
|
	I32OCT
	{
		helper.mRuleDebugger.PrintRule("integer32 -> I32OCT");
		$$ = helper.OctToI32(*$1);
		delete $1;
	}
|
	I32DEC
	{
		helper.mRuleDebugger.PrintRule("integer32 -> I32DEC");
		$$ = helper.DecToI32(*$1);
		delete $1;
	}
|
	I32HEX
	{
		helper.mRuleDebugger.PrintRule("integer32 -> I32HEX");
		$$ = helper.HexToI32(*$1);
		delete $1;
	}
;

unsigned32:
	U32BIN
	{
		helper.mRuleDebugger.PrintRule("unsigned32 -> U32BIN");
		$$ = helper.BinToI32(*$1);
		delete $1;
	}
|
	U32OCT
	{
		helper.mRuleDebugger.PrintRule("unsigned32 -> U32OCT");
		$$ = helper.OctToI32(*$1);
		delete $1;
	}
|
	U32DEC
	{
		helper.mRuleDebugger.PrintRule("unsigned32 -> U32DEC");
		$$ = helper.DecToI32(*$1);
		delete $1;
	}
|
	U32HEX
	{
		helper.mRuleDebugger.PrintRule("unsigned32 -> U32HEX");
		$$ = helper.HexToI32(*$1);
		delete $1;
	}
;

integer64:
	I64BIN
	{
		helper.mRuleDebugger.PrintRule("integer64 -> I64BIN");
		$$ = helper.BinToI64(*$1);
		delete $1;
	}
|
	I64OCT
	{
		helper.mRuleDebugger.PrintRule("integer64 -> I64OCT");
		$$ = helper.OctToI64(*$1);
		delete $1;
	}
|
	I64DEC
	{
		helper.mRuleDebugger.PrintRule("integer64 -> I64DEC");
		$$ = helper.DecToI64(*$1);
		delete $1;
	}
|
	I64HEX
	{
		helper.mRuleDebugger.PrintRule("integer64 -> I64HEX");
		$$ = helper.HexToI64(*$1);
		delete $1;
	}
;

unsigned64:
	U64BIN
	{
		helper.mRuleDebugger.PrintRule("unsigned64 -> U64BIN");
		$$ = helper.BinToI64(*$1);
		delete $1;
	}
|
	U64OCT
	{
		helper.mRuleDebugger.PrintRule("unsigned64 -> U64OCT");
		$$ = helper.OctToI64(*$1);
		delete $1;
	}
|
	U64DEC
	{
		helper.mRuleDebugger.PrintRule("unsigned64 -> U64DEC");
		$$ = helper.DecToI64(*$1);
		delete $1;
	}
|
	U64HEX
	{
		helper.mRuleDebugger.PrintRule("unsigned64 -> U64HEX");
		$$ = helper.HexToI64(*$1);
		delete $1;
	}
;

ehandlers:
	// empty
	{
		helper.mRuleDebugger.PrintRule("ehandlers -> {empty}");
		$$ = new wtast::EHandlers();
	}
|
	ehandlerlist
	{
		helper.mRuleDebugger.PrintRule("ehandlers -> ehandlerlist");
		$$ = new wtast::EHandlers($1->begin(), $1->end());
		delete $1;
	}
;

ehandlerlist:
	KW_EXCEPTION LPAR DOTDOTDOT RPAR compound
	{
		helper.mRuleDebugger.PrintRule("ehandlerlist -> KW_EXCEPTION LPAR DOTDOTDOT RPAR compound");
		$$ = new ehandlerlist_t;
		$$->push_front(new wtast::EHandler("...", $5));
	}
|
	KW_EXCEPTION LPAR IDENTIFIER RPAR compound
	{
		helper.mRuleDebugger.PrintRule("ehandlerlist -> KW_EXCEPTION LPAR IDENTIFIER RPAR compound");
		helper.EnterEHandlerMode(true);
		$$ = new ehandlerlist_t;
		$$->push_front(new wtast::EHandler(*$3, $5));
		delete $3;
	}
|
	KW_EXCEPTION LPAR IDENTIFIER RPAR compound ehandlerlist
	{
		helper.mRuleDebugger.PrintRule("ehandlerlist -> KW_EXCEPTION LPAR IDENTIFIER RPAR compound ehandlerlist");
		$$ = $6;
		$$->push_front(new wtast::EHandler(*$3, $5));
		delete $3;
	}
;

finally:
	// empty
	{
		helper.mRuleDebugger.PrintRule("finally -> {empty}");
		$$ = new wtast::Finally();
	}
|
	KW_FINALLY { helper.EnterFinallyMode(true); helper.EnterEHandlerMode(true); } compound
	{
		helper.mRuleDebugger.PrintRule("finally -> KW_FINALLY compound");
		helper.LeaveFinallyMode();
		helper.LeaveEHandlerMode();
		$$ = new wtast::Finally($3);
	}
;

functionargument:
	type IDENTIFIER
	{
		helper.mRuleDebugger.PrintRule("functionargument -> type IDENTIFIER");
		$$ = helper.MakeFunctionArgument($1, *$2, false);
		delete $2;
	}
|
	KW_MUTABLE type IDENTIFIER
	{
		helper.mRuleDebugger.PrintRule("functionargument -> KW_MUTABLE type IDENTIFIER");
		$$ = helper.MakeFunctionArgument($2, *$3, true);
		delete $3;
	}
;

functionsignature:
	funcsig_start RPAR
	{
		helper.mRuleDebugger.PrintRule("functionsignature -> funcsig_start RPAR");
		wtast::FunctionSignature* funcsig = $1;
		funcsig->SetUniqueId(helper.GetFuncUniqueId(funcsig));
		$$ = funcsig;
	}
|
	funcsig_args RPAR
	{
		helper.mRuleDebugger.PrintRule("functionsignature -> funcsig_args RPAR");
		wtast::FunctionSignature* funcsig = $1;
		funcsig->SetUniqueId(helper.GetFuncUniqueId(funcsig));
		$$ = funcsig;
	}
|
	funcsig_rets
	{
		helper.mRuleDebugger.PrintRule("functionsignature -> funcsig_rets");
		wtast::FunctionSignature* funcsig = $1;
		funcsig->SetUniqueId(helper.GetFuncUniqueId(funcsig));
		$$ = funcsig;
	}
;

funcsig_start:
	KW_FUNCTION IDENTIFIER LPAR
	{
		helper.mRuleDebugger.PrintRule("funcsig_start -> FW_FUNCTION IDENTIFIER LPAR");
		$$ = new wtast::FunctionSignature(*$2, true);
		delete $2;
	}
|
	KW_FUNCTION string LPAR
	{
		helper.mRuleDebugger.PrintRule("funcsig_start -> FW_FUNCTION string LPAR");
		$$ = new wtast::FunctionSignature(*$2, true);
		delete $2;
	}
|
	KW_PURE KW_FUNCTION IDENTIFIER LPAR
	{
		helper.mRuleDebugger.PrintRule("funcsig_start -> KW_PURE FW_FUNCTION IDENTIFIER LPAR");
		$$ = new wtast::FunctionSignature(*$3, true);
		delete $3;
	}
|
	KW_PURE KW_FUNCTION string LPAR
	{
		helper.mRuleDebugger.PrintRule("funcsig_start -> KW_PURE FW_FUNCTION string LPAR");
		$$ = new wtast::FunctionSignature(*$3, true);
		delete $3;
	}
|
	KW_IMPURE KW_FUNCTION IDENTIFIER LPAR
	{
		helper.mRuleDebugger.PrintRule("funcsig_start -> KW_IMPURE FW_FUNCTION IDENTIFIER LPAR");
		$$ = new wtast::FunctionSignature(*$3, false);
		delete $3;
	}
|
	KW_IMPURE KW_FUNCTION string LPAR
	{
		helper.mRuleDebugger.PrintRule("funcsig_start -> KW_IMPURE FW_FUNCTION string LPAR");
		$$ = new wtast::FunctionSignature(*$3, false);
		delete $3;
	}
;

funcsig_args:
	funcsig_start functionargument
	{
		helper.mRuleDebugger.PrintRule("funcsig_args -> funcsig_start functionargument");
		$$ = $1;
		$$->AddArgBack($2);
	}
|
	funcsig_args COMMA functionargument
	{
		helper.mRuleDebugger.PrintRule("funcsig_args -> funcsig_args COMMA functionargument");
		$$ = $1;
		$$->AddArgBack($3);
	}
;

funcsig_rets:
	funcsig_start RPAR COLON type
	{
		helper.mRuleDebugger.PrintRule("funcsig_rets -> funcsig_start RPAR COLON type");
		$$ = $1;
		$$->AddRetBack($4);
	}
|
	funcsig_args RPAR COLON type
	{
		helper.mRuleDebugger.PrintRule("funcsig_rets -> funcsig_args RPAR COLON type");
		$$ = $1;
		$$->AddRetBack($4);
	}
|
	funcsig_rets COMMA type
	{
		helper.mRuleDebugger.PrintRule("funcsig_rets -> funcsig_rets COMMA type");
		$$ = $1;
		$$->AddRetBack($3);
	}
;

compound:
	LBRACE { if(!helper.mSymTab.EnterBlock()) { helper.PostError("Out of memory."); } } statements RBRACE
	{
		helper.mRuleDebugger.PrintRule("compound -> LBRACE statements RBRACE");
		$$ = new wtast::Compound($3->begin(), $3->end(), "");
		helper.mSymTab.LeaveBlock();
		delete $3;
	}
|
	IDENTIFIER LBRACE { if(!helper.mSymTab.EnterBlock(*$1)) { helper.PostError("Out of memory."); } } statements RBRACE
	{
		helper.mRuleDebugger.PrintRule("compound -> IDENTIFIER LBRACE statements RBRACE");
		$$ = new wtast::Compound($4->begin(), $4->end(), *$1);
		helper.mSymTab.LeaveBlock();
		delete $1;
		delete $4;
	}
;

statements:
	// empty
	{
		helper.mRuleDebugger.PrintRule("statements -> {empty}");
		$$ = new statements_t;
	}
|
	statement
	{
		helper.mRuleDebugger.PrintRule("statements -> statement");
		$$ = new statements_t;
		if($1)
		{
			$$->push_back($1);
		}
	}
|
	statements statement
	{
		helper.mRuleDebugger.PrintRule("statements -> statements statement");
		$$ = $1;
		if($2)
		{
			$$->push_back($2);
		}
	}
;

statement:
	variabledeclaration
	{
		helper.mRuleDebugger.PrintRule("statement -> variabledeclaration");
		$$ = $1;
	}
|
	compound
	{
		helper.mRuleDebugger.PrintRule("statement -> compound");
		$$ = $1;
	}
|
	assignment SEMICOLON
	{
		helper.mRuleDebugger.PrintRule("statement -> assignment");
		$$ = $1;
	}
|
	funccallexpr SEMICOLON
	{
		helper.mRuleDebugger.PrintRule("statement -> funccallexpr SEMICOLON");
		if(helper.ExpressionHasNoType($1))
		{
			$$ = new wtast::ProcedureCall($1);
		}
		else
		{
			$$ = 0;
			helper.PostError("Function has return values, but not in assignment.");
		}
	}
|
	KW_RETURN SEMICOLON
	{
		helper.mRuleDebugger.PrintRule("statement -> KW_RETURN SEMICOLON");
		$$ = helper.MakeReturnStatement(0);
	}
|
	KW_RETURN expression SEMICOLON
	{
		helper.mRuleDebugger.PrintRule("statement -> KW_RETURN expression SEMICOLON");
		$$ = helper.MakeReturnStatement($2);
	}
|
	KW_RAISE LPAR IDENTIFIER RPAR SEMICOLON
	{
		helper.mRuleDebugger.PrintRule("statement -> KW_RAISE LPAR IDENTIFIER RPAR SEMICOLON");
		$$ = helper.MakeRaiseStatement(*$3, false);
		delete $3;
	}
|
	KW_RAISENEAR LPAR IDENTIFIER RPAR SEMICOLON
	{
		helper.mRuleDebugger.PrintRule("statement -> KW_RAISENEAR LPAR IDENTIFIER RPAR SEMICOLON");
		$$ = helper.MakeRaiseStatement(*$3, true);
		delete $3;
	}
|
	KW_WHILE LPAR expression RPAR compound
	{
		helper.mRuleDebugger.PrintRule("statement -> KW_WHILE LPAR expression RPAR compound");
		$$ = helper.MakeWhileStatement($3, $5);
	}
|
	KW_DO compound KW_WHILE LPAR expression RPAR SEMICOLON
	{
		helper.mRuleDebugger.PrintRule("statement -> KW_DO compound KW_WHILE LPAR expression RPAR SEMICOLON");
		$$ = helper.MakeDoWhileStatement($2, $5);
	}
|
	KW_FOR LPAR assignment_opt SEMICOLON expression_opt SEMICOLON assignment_opt RPAR compound
	{
		helper.mRuleDebugger.PrintRule("statement -> KW_FOR LPAR assignment_opt SEMICOLON expression_opt SEMICOLON assignment_opt RPAR compound");
		$$ = helper.MakeForStatement($3, $5, $7, $9);
	}
|
	KW_FOREACH LPAR IDENTIFIER KW_IN expression DOTDOT expression
	{
		$<variabledeclaration>$ = helper.EnterForeachBlock(*$3, $5, true);
	}
	inclusive_opt reverse_opt foreach_while foreach_which RPAR compound
	{
		helper.mRuleDebugger.PrintRule("statement -> KW_FOREACH LPAR IDENTIFIER KW_IN expression DOTDOT expression inclusive_opt reverse_opt foreach_while foreach_which RPAR compound");
		wtast::VariableDeclaration* vardecl = $<variabledeclaration>8;
		$$ = helper.MakeForeachStatement(vardecl, $5, $7, $9, $10, $11, $12, $14);
		if(vardecl)
		{
			helper.mSymTab.LeaveBlock();
		}
		delete $3;
	}
|
	KW_FOREACH LPAR IDENTIFIER KW_IN expression
	{
		$<variabledeclaration>$ = helper.EnterForeachBlock(*$3, $5, false);
	}
	reverse_opt foreach_while foreach_which RPAR compound
	{
		helper.mRuleDebugger.PrintRule("statement -> KW_FOREACH LPAR IDENTIFIER KW_IN expression reverse_opt foreach_while foreach_which RPAR compound");
		wtast::VariableDeclaration* vardecl = $<variabledeclaration>6;
		$$ = helper.MakeForeachStatement(vardecl, $5, $7, $8, $9, $11);
		if(vardecl)
		{
			helper.mSymTab.LeaveBlock();
		}
		delete $3;
	}
|
	KW_IF LPAR expression RPAR compound elsestatement
	{
		helper.mRuleDebugger.PrintRule("statement -> KW_IF LPAR expression RPAR compound elsestatement");
		$$ = helper.MakeIfStatement($3, $5, $6);
	}
|
	KW_ASSERT LPAR expression RPAR SEMICOLON
	{
		helper.mRuleDebugger.PrintRule("statement -> KW_ASSERT LPAR expression RPAR SEMICOLON");
		$$ = helper.MakeAssertStatement($3);
	}
|
	KW_SWITCH LPAR expression RPAR
	{
		helper.PushSwitchExpression($3);
	}
	LBRACE switchcases default_opt RBRACE
	{
		helper.mRuleDebugger.PrintRule("statement -> KW_SWITCH LPAR expression RPAR LBRACE switchcases default_opt RBRACE");
		$$ = helper.MakeSwitchStatement($3, $7, $8);
		helper.PopSwitchExpression();
	}
;

elsestatement:
	// empty
	{
		helper.mRuleDebugger.PrintRule("elsestatement -> {empty}");
		$$ = 0;
	}
|
	KW_ELSE compound
	{
		helper.mRuleDebugger.PrintRule("elsestatement -> KW_ELSE compound");
		$$ = $2;
	}
|
	KW_ELIF LPAR expression RPAR compound elsestatement
	{
		helper.mRuleDebugger.PrintRule("elsestatement -> KW_ELIF LPAR expression RPAR compound elsestatement");
		$$ = helper.MakeIfStatement($3, $5, $6);
	}
;

foreach_while:
	// empty
	{
		helper.mRuleDebugger.PrintRule("foreach_while -> {empty}");
		$$ = 0;
	}
|
	KW_WHILE expression
	{
		helper.mRuleDebugger.PrintRule("foreach_while -> KW_WHILE expression");
		$$ = $2;
	}
;

foreach_which:
	// empty
	{
		helper.mRuleDebugger.PrintRule("foreach_which -> {empty}");
		$$ = 0;
	}
|
	KW_WHICH expression
	{
		helper.mRuleDebugger.PrintRule("foreach_which -> KW_WHICH expression");
		$$ = $2;
	}
;

inclusive_opt:
	// empty
	{
		helper.mRuleDebugger.PrintRule("inclusive_opt -> {empty}");
		$$ = true;
	}
|
	KW_INCLUSIVE
	{
		helper.mRuleDebugger.PrintRule("inclusive_opt -> KW_INCLUSIVE");
		$$ = true;
	}
|
	KW_EXCLUSIVE
	{
		helper.mRuleDebugger.PrintRule("inclusive_opt -> KW_EXCLUSIVE");
		$$ = false;
	}
;

reverse_opt:
	// empty
	{
		helper.mRuleDebugger.PrintRule("reverse_opt -> {empty}");
		$$ = false;
	}
|
	KW_REVERSE
	{
		helper.mRuleDebugger.PrintRule("reverse_opt -> KW_REVERSE");
		$$ = true;
	}
;

switchcases:
	switchcase
	{
		helper.mRuleDebugger.PrintRule("switchcases -> switchcase");
		$$ = new switchcases_t;
		$$->push_back($1);
	}
|
	switchcases switchcase
	{
		helper.mRuleDebugger.PrintRule("switchcases -> switchcases switchcase");
		$$ = $1;
		$$->push_back($2);
	}
;

switchcase:
	KW_CASE SPECIALIDENT identlist COLON
	{
		if(!helper.mSymTab.EnterBlock()) { helper.PostError("Out of memory."); }
		$<variabledecls>$ = helper.AddCaseVariables(*$2, $3);
	}
	compound
	{
		helper.mRuleDebugger.PrintRule("switchcase -> KW_CASE SPECIALIDENT identlist COLON compound");
		variabledecls_t* vars = $<variabledecls>5;
		$$ = helper.MakeDataTypeCaseStatement(*$2, vars, $6);
		helper.mSymTab.LeaveBlock();
		delete vars;
		delete $2;
	}
|
	KW_CASE TYPENAME COLONCOLON SPECIALIDENT identlist COLON
	{
		if(!helper.mSymTab.EnterBlock()) { helper.PostError("Out of memory."); }
		$<variabledecls>$ = helper.AddCaseVariables(*$2, *$4, $5);
	}
	compound
	{
		helper.mRuleDebugger.PrintRule("switchcase -> KW_CASE TYPENAME COLONCOLON SPECIALIDENT identlist COLON compound");
		variabledecls_t* vars = $<variabledecls>7;
		$$ = helper.MakeDataTypeCaseStatement(*$2, *$4, vars, $8);
		helper.mSymTab.LeaveBlock();
		delete vars;
		delete $2;
		delete $4;
	}
|
	KW_CASE SPECIALIDENT COLON compound
	{
		helper.mRuleDebugger.PrintRule("switchcase -> KW_CASE SPECIALIDENT COLON compound");
		$$ = helper.MakeSpecialCaseStatement(*$2, $4);
		delete $2;
	}
|
	KW_CASE TYPENAME COLONCOLON SPECIALIDENT COLON compound
	{
		helper.mRuleDebugger.PrintRule("switchcase -> KW_CASE TYPENAME COLONCOLON SPECIALIDENT COLON compound");
		$$ = helper.MakeSpecialCaseStatement(*$2, *$4, $6);
		delete $2;
		delete $4;
	}
;

default_opt:
	// empty
	{
		helper.mRuleDebugger.PrintRule("default_opt -> {empty}");
		$$ = 0;
	}
|
	KW_DEFAULT COLON compound
	{
		helper.mRuleDebugger.PrintRule("default_opt -> KW_DEFAULT COLON compound");
		$$ = helper.MakeDefaultStatement($3);
	}
;

variabledeclaration:
	type IDENTIFIER
	{
		helper.mRuleDebugger.PrintRule("variabledeclaration -> type IDENTIFIER");
		$$ = new wtast::VariableDeclaration($1);
		const std::string & ident = *$2;
		UniqueId unique_id = helper.CreateUniqueId();
		if(helper.mSymTab.AddVariable($$->GetType(), ident, unique_id, helper._GetEHandlerMode(), helper.GetCurrentVariableClass()))
		{
			$$->AddFragment(new wtast::VariableDeclFragment($$, ident, unique_id));
		}
		else
		{
			helper.PostError(std::string("Multiple variable declaration of '") + ident + "'");
		}
		delete $2;
	}
|
	variabledeclaration COMMA IDENTIFIER
	{
		helper.mRuleDebugger.PrintRule("variabledeclaration -> variabledeclaration COMMA IDENTIFIER");
		$$ = $1;
		const std::string & ident = *$3;
		UniqueId unique_id = helper.CreateUniqueId();
		if(helper.mSymTab.AddVariable($$->GetType(), ident, unique_id, helper._GetEHandlerMode(), helper.GetCurrentVariableClass()))
		{
			$$->AddFragment(new wtast::VariableDeclFragment($$, ident, unique_id));
		}
		else
		{
			helper.PostError(std::string("Multiple variable declaration of '") + ident + "'");
		}
		delete $3;
	}
|
	variabledeclaration SEMICOLON
	{
		helper.mRuleDebugger.PrintRule("variabledeclaration -> variabledeclaration SEMICOLON");
		$$ = $1;
		helper.ValidateUninitializedVariable($$);
	}
|
	variabledeclaration ASSIGN expression SEMICOLON
	{
		helper.mRuleDebugger.PrintRule("variabledeclaration -> variabledeclaration ASSIGN expression SEMICOLON");
		$$ = $1;
		if(helper.ValidateInitialValue($$, $3))
		{
			$$->SetInitialValue($3);
		}
	}
;

variabledeclarations:
	variabledeclaration
	{
		helper.mRuleDebugger.PrintRule("variabledeclarations -> variabledeclaration");
		$$ = new variabledecls_t;
		$$->push_back($1);
	}
|
	variabledeclarations variabledeclaration
	{
		helper.mRuleDebugger.PrintRule("variabledeclarations -> variabledeclarations variabledeclaration");
		$$ = $1;
		$$->push_back($2);
	}
;

type:
	TYPE_CHAR
	{
		helper.mRuleDebugger.PrintRule("type -> TYPE_CHAR");
		$$ = helper.GetStockType(WTT_CHAR);
	}
|
	TYPE_BOOL
	{
		helper.mRuleDebugger.PrintRule("type -> TYPE_BOOL");
		$$ = helper.GetStockType(WTT_BOOL);
	}
|
	TYPE_HANDLE
	{
		helper.mRuleDebugger.PrintRule("type -> TYPE_HANDLE");
		$$ = helper.GetStockType(WTT_HANDLE);
	}
|
	TYPE_STRING
	{
		helper.mRuleDebugger.PrintRule("type -> TYPE_STRING");
		$$ = helper.GetStockType(WTT_STRING);
	}
|
	TYPE_FILE
	{
		helper.mRuleDebugger.PrintRule("type -> TYPE_FILE");
		$$ = helper.GetStockType(WTT_FILE);
	}
|
	TYPE_DIR
	{
		helper.mRuleDebugger.PrintRule("type -> TYPE_DIR");
		$$ = helper.GetStockType(WTT_DIR);
	}
|
	TYPE_I8
	{
		helper.mRuleDebugger.PrintRule("type -> TYPE_I8");
		$$ = helper.GetStockType(WTT_I8);
	}
|
	TYPE_U8
	{
		helper.mRuleDebugger.PrintRule("type -> TYPE_U8");
		$$ = helper.GetStockType(WTT_U8);
	}
|
	TYPE_I16
	{
		helper.mRuleDebugger.PrintRule("type -> TYPE_I16");
		$$ = helper.GetStockType(WTT_I16);
	}
|
	TYPE_U16
	{
		helper.mRuleDebugger.PrintRule("type -> TYPE_U16");
		$$ = helper.GetStockType(WTT_U16);
	}
|
	TYPE_I32
	{
		helper.mRuleDebugger.PrintRule("type -> TYPE_I32");
		$$ = helper.GetStockType(WTT_I32);
	}
|
	TYPE_U32
	{
		helper.mRuleDebugger.PrintRule("type -> TYPE_U32");
		$$ = helper.GetStockType(WTT_U32);
	}
|
	TYPE_I64
	{
		helper.mRuleDebugger.PrintRule("type -> TYPE_I64");
		$$ = helper.GetStockType(WTT_I64);
	}
|
	TYPE_U64
	{
		helper.mRuleDebugger.PrintRule("type -> TYPE_U64");
		$$ = helper.GetStockType(WTT_U64);
	}
|
	TYPE_F32
	{
		helper.mRuleDebugger.PrintRule("type -> TYPE_F32");
		$$ = helper.GetStockType(WTT_F32);
	}
|
	TYPE_F64
	{
		helper.mRuleDebugger.PrintRule("type -> TYPE_F64");
		$$ = helper.GetStockType(WTT_F64);
	}
|
	TYPENAME
	{
		helper.mRuleDebugger.PrintRule("type -> TYPENAME");
		$$ = helper.ResolveType(*$1);
		delete $1;
	}
|
	KW_SEQ LANGLEBRACKET type RANGLEBRACKET
	{
		helper.mRuleDebugger.PrintRule("type -> KW_SEQ LANGLEBRACKET type RANGLEBRACKET");
		$$ = helper.GetSeqType($3);
	}
;

expression_opt:
	// empty
	{
		helper.mRuleDebugger.PrintRule("expression_opt -> {empty}");
		$$ = 0;
	}
|
	expression
	{
		helper.mRuleDebugger.PrintRule("expression_opt -> expression");
		$$ = $1;
	}
;

expression:
	COLONCOLON IDENTIFIER
	{
		helper.mRuleDebugger.PrintRule("expression -> COLONCOLON IDENTIFIER");
		$$ = helper.ResolveGlobalFunctionName(*$2);
		delete $2;
	}
|
	COLONCOLON STRINGLIT
	{
		helper.mRuleDebugger.PrintRule("expression -> COLONCOLON STRINGLIT");
		$$ = helper.ResolveGlobalFunctionName(helper.ValidateFunctionName(*$2));
		delete $2;
	}
|
	expression COMMA expression
	{
		helper.mRuleDebugger.PrintRule("expression -> expression COMMA expression");
		if($1 && $1->IsSimultaneous())
		{
			$$ = $1;
			static_cast<wtast::SimultaneousExpression*>($$)->AddExpression(helper.ValidateExpression($3));
		}
		else
		{
			$$ = new wtast::SimultaneousExpression(helper.ValidateExpression($1), helper.ValidateExpression($3));
		}
	}
|
	LPAR expression RPAR
	{
		helper.mRuleDebugger.PrintRule("expression -> LPAR expression RPAR");
		$$ = $2;
	}
|
	funccallexpr
	{
		helper.mRuleDebugger.PrintRule("expression -> funccallexpr");
		$$ = $1;
	}
|
	string
	{
		helper.mRuleDebugger.PrintRule("expression -> string");
		$$ = new wtast::StringLiteral(helper.GetStockType(WTT_STRING), *$1);
		delete $1;
	}
|
	KW_TRUE
	{
		helper.mRuleDebugger.PrintRule("expression -> KW_TRUE");
		$$ = new wtast::BooleanLiteral(helper.GetStockType(WTT_BOOL), WT_TRUE);
	}
|
	KW_FALSE
	{
		helper.mRuleDebugger.PrintRule("expression -> KW_FALSE");
		$$ = new wtast::BooleanLiteral(helper.GetStockType(WTT_BOOL), WT_FALSE);
	}
|
	CHARLIT
	{
		helper.mRuleDebugger.PrintRule("expression -> CHARLIT");
		$$ = new wtast::CharacterLiteral(helper.GetStockType(WTT_CHAR), helper.ParseChar(*$1));
		delete $1;
	}
|
	FLOATNUMBER
	{
		helper.mRuleDebugger.PrintRule("expression -> FLOATNUMBER");
		$$ = new wtast::NumberLiteral(helper.GetStockType(WTT_F32), helper.ParseF32(*$1));
		delete $1;
	}
|
	DOUBLENUMBER
	{
		helper.mRuleDebugger.PrintRule("expression -> DOUBLENUMBER");
		$$ = new wtast::NumberLiteral(helper.GetStockType(WTT_F64), helper.ParseF64(*$1));
		delete $1;
	}
|
	integer8
	{
		helper.mRuleDebugger.PrintRule("expression -> integer8");
		$$ = new wtast::NumberLiteral(helper.GetStockType(WTT_I8), $1);
	}
|
	unsigned8
	{
		helper.mRuleDebugger.PrintRule("expression -> unsigned8");
		$$ = new wtast::NumberLiteral(helper.GetStockType(WTT_U8), $1);
	}
|
	integer16
	{
		helper.mRuleDebugger.PrintRule("expression -> integer16");
		$$ = new wtast::NumberLiteral(helper.GetStockType(WTT_I16), $1);
	}
|
	unsigned16
	{
		helper.mRuleDebugger.PrintRule("expression -> unsigned16");
		$$ = new wtast::NumberLiteral(helper.GetStockType(WTT_U16), $1);
	}
|
	integer32
	{
		helper.mRuleDebugger.PrintRule("expression -> integer32");
		$$ = new wtast::NumberLiteral(helper.GetStockType(WTT_I32), $1);
	}
|
	unsigned32
	{
		helper.mRuleDebugger.PrintRule("expression -> unsigned32");
		$$ = new wtast::NumberLiteral(helper.GetStockType(WTT_U32), $1);
	}
|
	integer64
	{
		helper.mRuleDebugger.PrintRule("expression -> integer64");
		$$ = new wtast::NumberLiteral(helper.GetStockType(WTT_I64), $1);
	}
|
	unsigned64
	{
		helper.mRuleDebugger.PrintRule("expression -> unsigned64");
		$$ = new wtast::NumberLiteral(helper.GetStockType(WTT_U64), $1);
	}
|
	lvalue
	{
		helper.mRuleDebugger.PrintRule("expression -> lvalue");
		$$ = $1;
	}
|
	KW_SEQ LANGLEBRACKET type RANGLEBRACKET LBRACE RBRACE
	{
		helper.mRuleDebugger.PrintRule("expression -> KW_SEQ LANGLEBRACKET type RANGLEBRACKET LBRACE RBRACE");
		$$ = helper.MakeSeqLiteral($3, 0);
	}
|
	KW_SEQ LANGLEBRACKET type RANGLEBRACKET LBRACE expression RBRACE
	{
		helper.mRuleDebugger.PrintRule("expression -> KW_SEQ LANGLEBRACKET type RANGLEBRACKET LBRACE expression RBRACE");
		$$ = helper.MakeSeqLiteral($3, $6);
	}
|
	KW_SEQ LBRACE expression RBRACE
	{
		helper.mRuleDebugger.PrintRule("expression -> KW_SEQ LBRACE expression RBRACE");
		$$ = helper.MakeSeqLiteral(0, $3);
	}
|
	TYPENAME LBRACE RBRACE
	{
		helper.mRuleDebugger.PrintRule("expression -> TYPENAME LBRACE RBRACE");
		$$ = helper.MakeRecordLiteral(*$1, 0, 0);
		delete $1;
	}
|
	TYPENAME LBRACE expression RBRACE
	{
		helper.mRuleDebugger.PrintRule("expression -> TYPENAME LBRACE expression RBRACE");
		$$ = helper.MakeRecordLiteral(*$1, $3, 0);
		delete $1;
	}
|
	TYPENAME LBRACE fieldassigns RBRACE
	{
		helper.mRuleDebugger.PrintRule("expression -> TYPENAME LBRACE fieldassigns RBRACE");
		$$ = helper.MakeRecordLiteral(*$1, 0, $3);
		delete $1;
	}
|
	LPAR expression RPAR LBRACE fieldassigns RBRACE
	{
		helper.mRuleDebugger.PrintRule("expression -> LPAR expression RPAR LBRACE fieldassigns RBRACE");
		$$ = helper.MakeRecordUpdate($2, $5);
	}
|
	SPECIALIDENT
	{
		helper.mRuleDebugger.PrintRule("expression -> SPECIALIDENT");
		$$ = helper.MakeSpecialLiteral(*$1);
		delete $1;
	}
|
	SPECIALIDENT LBRACE expression RBRACE
	{
		helper.mRuleDebugger.PrintRule("expression -> SPECIALIDENT LBRACE expression RBRACE");
		$$ = helper.MakeDataTypeLiteral(*$1, $3);
		delete $1;
	}
|
	TYPENAME COLONCOLON SPECIALIDENT
	{
		helper.mRuleDebugger.PrintRule("expression -> TYPENAME COLONCOLON SPECIALIDENT");
		$$ = helper.MakeSpecialLiteral(*$1, *$3);
		delete $1;
		delete $3;
	}
|
	TYPENAME COLONCOLON SPECIALIDENT LBRACE expression RBRACE
	{
		helper.mRuleDebugger.PrintRule("expression -> TYPENAME COLONCOLON SPECIALIDENT LBRACE expression RBRACE");
		$$ = helper.MakeDataTypeLiteral(*$1, *$3, $5);
		delete $1;
		delete $3;
	}
|
	TYPENAME LPAR IDENTIFIER RPAR
	{
		helper.mRuleDebugger.PrintRule("expression -> TYPENAME LPAR IDENTIFIER RPAR");
		$$ = helper.MakeMakeFunctionPointer(*$1, *$3);
		delete $1;
		delete $3;
	}
|
	TYPENAME LPAR STRINGLIT RPAR
	{
		helper.mRuleDebugger.PrintRule("expression -> TYPENAME LPAR STRINGLIT RPAR");
		$$ = helper.MakeMakeFunctionPointer(*$1, helper.ValidateFunctionName(*$3));
		delete $1;
		delete $3;
	}
;

funccallexpr:
	expression LPAR RPAR
	{
		helper.mRuleDebugger.PrintRule("funccallexpr -> expression LPAR RPAR");
		$$ = helper.ResolveFunctionCall($1, 0);
	}
|
	expression LPAR expression RPAR
	{
		helper.mRuleDebugger.PrintRule("funccallexpr -> expression LPAR expression RPAR");
		$$ = helper.ResolveFunctionCall($1, $3);
	}
|
	expression OP_LORELSE expression
	{
		helper.mRuleDebugger.PrintRule("funccallexpr -> expression OP_LORELSE expression");
		$$ = helper.MakeOrElse($1, $3);
		delete $2;
	}
|
	expression OP_LANDTHEN expression
	{
		helper.mRuleDebugger.PrintRule("funccallexpr -> expression OP_LANDTHEN expression");
		$$ = helper.MakeAndThen($1, $3);
		delete $2;
	}
|
	expression OP_LEFT03 expression
	{
		helper.mRuleDebugger.PrintRule("funccallexpr -> expression OP_LEFT03 expression");
		$$ = helper.ApplyBinaryOperator($1, *$2, $3);
		delete $2;
	}
|
	expression OP_RIGHT03 expression
	{
		helper.mRuleDebugger.PrintRule("funccallexpr -> expression OP_RIGHT03 expression");
		$$ = helper.ApplyBinaryOperator($1, *$2, $3);
		delete $2;
	}
|
	expression OP_LEFT04 expression
	{
		helper.mRuleDebugger.PrintRule("funccallexpr -> expression OP_LEFT04 expression");
		$$ = helper.ApplyBinaryOperator($1, *$2, $3);
		delete $2;
	}
|
	expression OP_RIGHT04 expression
	{
		helper.mRuleDebugger.PrintRule("funccallexpr -> expression OP_RIGHT04 expression");
		$$ = helper.ApplyBinaryOperator($1, *$2, $3);
		delete $2;
	}
|
	expression OP_LEFT05 expression
	{
		helper.mRuleDebugger.PrintRule("funccallexpr -> expression OP_LEFT05 expression");
		$$ = helper.ApplyBinaryOperator($1, *$2, $3);
		delete $2;
	}
|
	expression OP_RIGHT05 expression
	{
		helper.mRuleDebugger.PrintRule("funccallexpr -> expression OP_RIGHT05 expression");
		$$ = helper.ApplyBinaryOperator($1, *$2, $3);
		delete $2;
	}
|
	expression OP_LEFT06 expression
	{
		helper.mRuleDebugger.PrintRule("funccallexpr -> expression OP_LEFT06 expression");
		$$ = helper.ApplyBinaryOperator($1, *$2, $3);
		delete $2;
	}
|
	expression OP_RIGHT06 expression
	{
		helper.mRuleDebugger.PrintRule("funccallexpr -> expression OP_RIGHT06 expression");
		$$ = helper.ApplyBinaryOperator($1, *$2, $3);
		delete $2;
	}
|
	expression OP_LEFT07 expression
	{
		helper.mRuleDebugger.PrintRule("funccallexpr -> expression OP_LEFT07 expression");
		$$ = helper.ApplyBinaryOperator($1, *$2, $3);
		delete $2;
	}
|
	expression OP_RIGHT07 expression
	{
		helper.mRuleDebugger.PrintRule("funccallexpr -> expression OP_RIGHT07 expression");
		$$ = helper.ApplyBinaryOperator($1, *$2, $3);
		delete $2;
	}
|
	expression OP_LEFT08 expression
	{
		helper.mRuleDebugger.PrintRule("funccallexpr -> expression OP_LEFT08 expression");
		$$ = helper.ApplyBinaryOperator($1, *$2, $3);
		delete $2;
	}
|
	expression OP_RIGHT08 expression
	{
		helper.mRuleDebugger.PrintRule("funccallexpr -> expression OP_RIGHT08 expression");
		$$ = helper.ApplyBinaryOperator($1, *$2, $3);
		delete $2;
	}
|
	expression OP_LEFT09 expression
	{
		helper.mRuleDebugger.PrintRule("funccallexpr -> expression OP_LEFT09 expression");
		$$ = helper.ApplyBinaryOperator($1, *$2, $3);
		delete $2;
	}
|
	expression OP_RIGHT09 expression
	{
		helper.mRuleDebugger.PrintRule("funccallexpr -> expression OP_RIGHT09 expression");
		$$ = helper.ApplyBinaryOperator($1, *$2, $3);
		delete $2;
	}
|
	expression OP_LEFT10 expression
	{
		helper.mRuleDebugger.PrintRule("funccallexpr -> expression OP_LEFT10 expression");
		$$ = helper.ApplyBinaryOperator($1, *$2, $3);
		delete $2;
	}
|
	expression OP_RIGHT10 expression
	{
		helper.mRuleDebugger.PrintRule("funccallexpr -> expression OP_RIGHT10 expression");
		$$ = helper.ApplyBinaryOperator($1, *$2, $3);
		delete $2;
	}
|
	expression OP_LEFT11 expression
	{
		helper.mRuleDebugger.PrintRule("funccallexpr -> expression OP_LEFT11 expression");
		$$ = helper.ApplyBinaryOperator($1, *$2, $3);
		delete $2;
	}
|
	expression LANGLEBRACKET expression
	{
		helper.mRuleDebugger.PrintRule("funccallexpr -> expression LANGLEBRACKET expression");
		$$ = helper.ApplyBinaryOperator($1, *$2, $3);
		delete $2;
	}
|
	expression RANGLEBRACKET expression
	{
		helper.mRuleDebugger.PrintRule("funccallexpr -> expression RANGLEBRACKET expression");
		$$ = helper.ApplyBinaryOperator($1, *$2, $3);
		delete $2;
	}
|
	expression OP_RIGHT11 expression
	{
		helper.mRuleDebugger.PrintRule("funccallexpr -> expression OP_RIGHT11 expression");
		$$ = helper.ApplyBinaryOperator($1, *$2, $3);
		delete $2;
	}
|
	expression OP_LEFT12 expression
	{
		helper.mRuleDebugger.PrintRule("funccallexpr -> expression OP_LEFT12 expression");
		$$ = helper.ApplyBinaryOperator($1, *$2, $3);
		delete $2;
	}
|
	expression OP_RIGHT12 expression
	{
		helper.mRuleDebugger.PrintRule("funccallexpr -> expression OP_RIGHT12 expression");
		$$ = helper.ApplyBinaryOperator($1, *$2, $3);
		delete $2;
	}
|
	expression OP_LEFT13 expression
	{
		helper.mRuleDebugger.PrintRule("funccallexpr -> expression OP_LEFT13 expression");
		$$ = helper.ApplyBinaryOperator($1, *$2, $3);
		delete $2;
	}
|
	expression OP_RIGHT13 expression
	{
		helper.mRuleDebugger.PrintRule("funccallexpr -> expression OP_RIGHT13 expression");
		$$ = helper.ApplyBinaryOperator($1, *$2, $3);
		delete $2;
	}
|
	expression OP_LEFT14 expression
	{
		helper.mRuleDebugger.PrintRule("funccallexpr -> expression OP_LEFT14 expression");
		$$ = helper.ApplyBinaryOperator($1, *$2, $3);
		delete $2;
	}
|
	expression OP_RIGHT14 expression
	{
		helper.mRuleDebugger.PrintRule("funccallexpr -> expression OP_RIGHT14 expression");
		$$ = helper.ApplyBinaryOperator($1, *$2, $3);
		delete $2;
	}
|
	expression OP_LEFT15 expression
	{
		helper.mRuleDebugger.PrintRule("funccallexpr -> expression OP_LEFT15 expression");
		$$ = helper.ApplyBinaryOperator($1, *$2, $3);
		delete $2;
	}
|
	expression OP_RIGHT15 expression
	{
		helper.mRuleDebugger.PrintRule("funccallexpr -> expression OP_RIGHT15 expression");
		$$ = helper.ApplyBinaryOperator($1, *$2, $3);
		delete $2;
	}
|
	expression OP_RIGHT03
	{
		helper.mRuleDebugger.PrintRule("funccallexpr -> expression OP_RIGHT03");
		$$ = helper.ApplyUnaryOperator($1, *$2);
		delete $2;
	}
|
	OP_LEFT03 expression
	{
		helper.mRuleDebugger.PrintRule("funccallexpr -> OP_LEFT03 expression");
		$$ = helper.ApplyUnaryOperator($2, *$1);
		delete $1;
	}
|
	expression OP_RIGHT04
	{
		helper.mRuleDebugger.PrintRule("funccallexpr -> expression OP_RIGHT04");
		$$ = helper.ApplyUnaryOperator($1, *$2);
		delete $2;
	}
|
	OP_LEFT04 expression
	{
		helper.mRuleDebugger.PrintRule("funccallexpr -> OP_LEFT04 expression");
		$$ = helper.ApplyUnaryOperator($2, *$1);
		delete $1;
	}
|
	expression OP_RIGHT05
	{
		helper.mRuleDebugger.PrintRule("funccallexpr -> expression OP_RIGHT05");
		$$ = helper.ApplyUnaryOperator($1, *$2);
		delete $2;
	}
|
	OP_LEFT05 expression
	{
		helper.mRuleDebugger.PrintRule("funccallexpr -> OP_LEFT05 expression");
		$$ = helper.ApplyUnaryOperator($2, *$1);
		delete $1;
	}
|
	expression OP_RIGHT06
	{
		helper.mRuleDebugger.PrintRule("funccallexpr -> expression OP_RIGHT06");
		$$ = helper.ApplyUnaryOperator($1, *$2);
		delete $2;
	}
|
	OP_LEFT06 expression
	{
		helper.mRuleDebugger.PrintRule("funccallexpr -> OP_LEFT06 expression");
		$$ = helper.ApplyUnaryOperator($2, *$1);
		delete $1;
	}
|
	expression OP_RIGHT07
	{
		helper.mRuleDebugger.PrintRule("funccallexpr -> expression OP_RIGHT07");
		$$ = helper.ApplyUnaryOperator($1, *$2);
		delete $2;
	}
|
	OP_LEFT07 expression
	{
		helper.mRuleDebugger.PrintRule("funccallexpr -> OP_LEFT07 expression");
		$$ = helper.ApplyUnaryOperator($2, *$1);
		delete $1;
	}
|
	expression OP_RIGHT08
	{
		helper.mRuleDebugger.PrintRule("funccallexpr -> expression OP_RIGHT08");
		$$ = helper.ApplyUnaryOperator($1, *$2);
		delete $2;
	}
|
	OP_LEFT08 expression
	{
		helper.mRuleDebugger.PrintRule("funccallexpr -> OP_LEFT08 expression");
		$$ = helper.ApplyUnaryOperator($2, *$1);
		delete $1;
	}
|
	expression OP_RIGHT09
	{
		helper.mRuleDebugger.PrintRule("funccallexpr -> expression OP_RIGHT09");
		$$ = helper.ApplyUnaryOperator($1, *$2);
		delete $2;
	}
|
	OP_LEFT09 expression
	{
		helper.mRuleDebugger.PrintRule("funccallexpr -> OP_LEFT09 expression");
		$$ = helper.ApplyUnaryOperator($2, *$1);
		delete $1;
	}
|
	expression OP_RIGHT10
	{
		helper.mRuleDebugger.PrintRule("funccallexpr -> expression OP_RIGHT10");
		$$ = helper.ApplyUnaryOperator($1, *$2);
		delete $2;
	}
|
	OP_LEFT10 expression
	{
		helper.mRuleDebugger.PrintRule("funccallexpr -> OP_LEFT10 expression");
		$$ = helper.ApplyUnaryOperator($2, *$1);
		delete $1;
	}
|
	expression OP_RIGHT11
	{
		helper.mRuleDebugger.PrintRule("funccallexpr -> expression OP_RIGHT11");
		$$ = helper.ApplyUnaryOperator($1, *$2);
		delete $2;
	}
|
	OP_LEFT11 expression
	{
		helper.mRuleDebugger.PrintRule("funccallexpr -> OP_LEFT11 expression");
		$$ = helper.ApplyUnaryOperator($2, *$1);
		delete $1;
	}
|
	LANGLEBRACKET expression
	{
		helper.mRuleDebugger.PrintRule("funccallexpr -> LANGLEBRACKET expression");
		$$ = helper.ApplyUnaryOperator($2, *$1);
		delete $1;
	}
|
	RANGLEBRACKET expression
	{
		helper.mRuleDebugger.PrintRule("funccallexpr -> RANGLEBRACKET expression");
		$$ = helper.ApplyUnaryOperator($2, *$1);
		delete $1;
	}
|
	expression OP_RIGHT12
	{
		helper.mRuleDebugger.PrintRule("funccallexpr -> expression OP_RIGHT12");
		$$ = helper.ApplyUnaryOperator($1, *$2);
		delete $2;
	}
|
	OP_LEFT12 expression
	{
		helper.mRuleDebugger.PrintRule("funccallexpr -> OP_LEFT12 expression");
		$$ = helper.ApplyUnaryOperator($2, *$1);
		delete $1;
	}
|
	expression OP_RIGHT13
	{
		helper.mRuleDebugger.PrintRule("funccallexpr -> expression OP_RIGHT13");
		$$ = helper.ApplyUnaryOperator($1, *$2);
		delete $2;
	}
|
	OP_LEFT13 expression
	{
		helper.mRuleDebugger.PrintRule("funccallexpr -> OP_LEFT13 expression");
		$$ = helper.ApplyUnaryOperator($2, *$1);
		delete $1;
	}
|
	expression OP_RIGHT14
	{
		helper.mRuleDebugger.PrintRule("funccallexpr -> expression OP_RIGHT14");
		$$ = helper.ApplyUnaryOperator($1, *$2);
		delete $2;
	}
|
	OP_LEFT14 expression
	{
		helper.mRuleDebugger.PrintRule("funccallexpr -> OP_LEFT14 expression");
		$$ = helper.ApplyUnaryOperator($2, *$1);
		delete $1;
	}
|
	expression OP_RIGHT15
	{
		helper.mRuleDebugger.PrintRule("funccallexpr -> expression OP_RIGHT15");
		$$ = helper.ApplyUnaryOperator($1, *$2);
		delete $2;
	}
|
	OP_LEFT15 expression
	{
		helper.mRuleDebugger.PrintRule("funccallexpr -> OP_LEFT15 expression");
		$$ = helper.ApplyUnaryOperator($2, *$1);
		delete $1;
	}
;

lvalue:
	IDENTIFIER
	{
		helper.mRuleDebugger.PrintRule("lvalue -> IDENTIFIER");
		$$ = helper.ResolveVariableAccess(*$1, SymTab::UnnamedFrame);
		delete $1;
	}
|
	IDENTIFIER COLONCOLON IDENTIFIER
	{
		helper.mRuleDebugger.PrintRule("lvalue -> IDENTIFIER COLONCOLON IDENTIFIER");
		$$ = helper.ResolveVariableAccess(*$3, *$1);
		delete $1;
		delete $3;
	}
|
	KW_GLOBAL COLONCOLON IDENTIFIER
	{
		helper.mRuleDebugger.PrintRule("lvalue -> KW_GLOBAL COLONCOLON IDENTIFIER");
		$$ = helper.ResolveVariableAccess(*$3, helper.GlobalBlockName);
		delete $3;
	}
|
	KW_MAIN COLONCOLON IDENTIFIER
	{
		helper.mRuleDebugger.PrintRule("lvalue -> KW_MAIN COLONCOLON IDENTIFIER");
		$$ = helper.ResolveVariableAccess(*$3, helper.MainBlockName);
		delete $3;
	}
|
	KW_CTOR COLONCOLON IDENTIFIER
	{
		helper.mRuleDebugger.PrintRule("lvalue -> KW_CTOR COLONCOLON IDENTIFIER");
		$$ = helper.ResolveVariableAccess(*$3, helper.CtorBlockName);
		delete $3;
	}
|
	KW_DTOR COLONCOLON IDENTIFIER
	{
		helper.mRuleDebugger.PrintRule("lvalue -> KW_DTOR COLONCOLON IDENTIFIER");
		$$ = helper.ResolveVariableAccess(*$3, helper.DtorBlockName);
		delete $3;
	}
|
	lvalue LBRACKET expression RBRACKET
	{
		helper.mRuleDebugger.PrintRule("lvalue -> lvalue LBRACKET expression RBRACKET");
		if($1 && $3)
		{
			wtast::TypeInfo* info = $1->GetType();
			wtast::TypeInfo* eti  = $3->GetType();

			if(helper.CanBeIndexed(info, eti))
			{
				wtast::TypeInfo* resultType = 0;

				if(WTT_STRING==(static_cast<wtast::Type*>(info)->GetTypeId() & ~WTTF_MUTABLE))
				{
					resultType = helper.GetStockType(WTT_CHAR);
				}
				else
				{
					resultType = static_cast<wtast::SeqType*>(info)->GetElementType();
				}

				$$ = new wtast::ElementAccess($1, $3, resultType);
			}
			else
			{
				helper.PostError(std::string("Cannot index '") + $1->GetType()->GetName() + "' type.");
				$$ = 0;
			}
		}
		else
		{
			$$ = 0;
		}
	}
|
	lvalue DOT IDENTIFIER
	{
		helper.mRuleDebugger.PrintRule("lvalue -> lvalue DOT IDENTIFIER");
		$$ = helper.ResolveMemberAccess($1, *$3);
		delete $3;
	}
|
	KW_OLD IDENTIFIER
	{
		helper.mRuleDebugger.PrintRule("lvalue -> KW_OLD IDENTIFIER");
		$$ = helper.ResolveVariableAccess(std::string("old ") + *$2, SymTab::UnnamedFrame);
		delete $2;
	}
;

assignment_opt:
	// empty
	{
		helper.mRuleDebugger.PrintRule("assignment_opt -> {empty}");
		$$ = 0;
	}
|
	assignment
	{
		helper.mRuleDebugger.PrintRule("assignment_opt -> assignment");
		$$ = $1;
	}
;

assignment:
	assignment_builder
	{
		helper.mRuleDebugger.PrintRule("assignment -> assignment_builder");
		helper.ValidateAssignment($1);
		$$ = $1;
	}
;

assignment_builder:
	lvalue ASSIGN expression
	{
		helper.mRuleDebugger.PrintRule("assignment_builder -> lvalue ASSIGN expression");
		$$ = new wtast::Assignment($1, $3);
	}
|
	lvalue COMMA assignment_builder
	{
		helper.mRuleDebugger.PrintRule("assignment_builder -> lvalue COMMA assignment_builder");
		$$ = $3;
		$$->AddFront($1);
	}
;

fieldassigns:
	fieldassign
	{
		helper.mRuleDebugger.PrintRule("fieldassigns -> fieldassign");
		$$ = new fieldassigns_t;
		$$->push_back($1);
	}
|
	fieldassigns fieldassign
	{
		helper.mRuleDebugger.PrintRule("fieldassigns -> fieldassigns fieldassign");
		$$ = $1;
		$$->push_back($2);
	}
;

fieldassign:
	DOT IDENTIFIER ASSIGN expression SEMICOLON
	{
		helper.mRuleDebugger.PrintRule("fieldassign -> DOT IDENTIFIER ASSIGN expression SEMICOLON");
		$$ = new wtast::FieldAssign($4);
		$$->AddFieldNameFront(*$2);
		delete $2;
	}
|
	DOT IDENTIFIER COMMA fieldassign
	{
		helper.mRuleDebugger.PrintRule("fieldassign -> DOT IDENTIFIER COMMA fieldassign");
		$$ = $4;
		$$->AddFieldNameFront(*$2);
		delete $2;
	}
;
